// EditWhite.cpp : implementation file
//

#include "stdafx.h"
#include "khan.h"
#include "EditWhite.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditWhite

// Create a brush for the background for the class of controls:
CBrush CEditWhite::m_brush(RGB(255,255,255));


CEditWhite::CEditWhite()
{
}

CEditWhite::~CEditWhite()
{
}


BEGIN_MESSAGE_MAP(CEditWhite, CEdit)
	//{{AFX_MSG_MAP(CEditWhite)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CEditWhite message handlers


// Set colors for Read-Only CEdit.
// See msdn: Q132080
BOOL CEditWhite::OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult) 
{
	// For a read-only CEdit, message is WM_CTLCOLORSTATIC (312 / 0x138),
	// otherwise WM_CTLCOLOREDIT. 
	if (message != WM_CTLCOLORSTATIC)
	{
		return CEdit::OnChildNotify(message,wParam,lParam,pLResult);
	}

	// Set the text foreground:
	HDC hdcChild = (HDC)wParam;
	SetTextColor(hdcChild, RGB(0 ,0 ,0));

	// Set the text background:
	SetBkColor(hdcChild, RGB(255,255,255));

	// Send what would have been the return value of OnCtlColor() - the
	// brush handle - back in pLResult:
	*pLResult = (LRESULT)(m_brush.GetSafeHandle());

	// Return TRUE to indicate that the message was handled:
	return TRUE;
}
