
'// revised for version 0.8.0
'// Hacked from: http://www.alkanesolutions.co.uk/vbscript_windowsinstaller_tutorials.aspx
'//         and: http://npramz.blogspot.com/2011/06/vbscripts-to-set-permission-via.html

'// Place this script in the msi folder.
'// Open the command prompt window. Note alt-enter toggles full screen.
'// Change current directory to the msi folder with:
'//  CD /D D:\Programming(D)\Workspaces\VS_2005 Workspaces\MFC\KhanDesktop\KhanSetup\Release
'// Run the script with:
'//  cscript.exe KhanSetPemissions2.vbs "KhanSetup.msi"


'// Some constants 
Const msiOpenDatabaseModeTransact = 1 
Const msiViewModifyInsert = 1
 
'// Create WindowsInstaller.Installer object
Dim oInstaller : Set oInstaller = CreateObject("WindowsInstaller.Installer")
 
'// Open the MSI (the first argument supplied to the vbscript)
Dim oDatabase : Set oDatabase = oInstaller.OpenDatabase(WScript.Arguments(0),msiOpenDatabaseModeTransact)


'//////////////////////////////////
'// Set permissions for KhanDb.dat 

wscript.echo "Setting permissions for KhanDb.dat file:"

Dim sql : sql = "SELECT File.File FROM `File` WHERE `FileName` = 'KHANDB.DAT|KhanDB.dat'"

'// Create a view
Dim regView : Set regView = oDatabase.OpenView(sql)
 
'// Execute the query
regView.Execute

'// File key variable
Dim fileKey : fileKey = ""
 
'// Fetch the row of data
Set regRecord = regView.Fetch

'// If no file
If regRecord Is Nothing Then
     wscript.echo "File Name not gotten"

'// Else file available to set permission on 
Else

    fileKey = regRecord.StringData(1)
    wscript.echo "File Key to set permission is: " &fileKey

    '// Select first
    '// Note wild syntax! '"& fileKey &"'
    sql = "SELECT `LockObject`,`Table`,`Domain`,`User`,`Permission` FROM `LockPermissions` WHERE `LockObject` = '"& fileKey &"'" 
    
     '// Create a view
    Set regView = oDatabase.OpenView(sql)
 
   '// Execute the query
    regView.Execute
    Set regRecord = regView.Fetch

   '// dbg
    'wscript.echo "LockObject = " & regRecord.StringData(1)
 
    '// If not existing, we create a new record.
    If regRecord Is Nothing Then

       '// wscript.echo "Dbg LockObject is: " &regRecord.StringData(1)
       wscript.echo "Seting permission for " &fileKey       
       Set regRecord = oInstaller.CreateRecord(5)
 
       '// Create record
       regRecord.StringData(1) = fileKey	'LockObject
       regRecord.StringData(2) = "File" 	'Table   
       regRecord.StringData(3) = ""		'Domain empty   
       regRecord.StringData(4) = "Everyone"    	'User
       regRecord.IntegerData(5) = 268435456	'Permission GENERIC_ALL
 
       regView.Modify msiViewModifyInsert,regRecord
       wscript.echo "Permission set for " &fileKey

       '// Save changes
       oDatabase.Commit

   Else
      wscript.echo "Permission is already set for: " &fileKey 
   End If
 
End If


'/////////////////////////////////////////////////////////
'// Set permissions for user.dat not needed. see original.
'/////////////////////////////////////////////////////////


'//////////////////////////////////////////////////////
'// Set permissions for COMMONAPPDATAFOLDER directory 

wscript.echo "Setting permissions for COMMONAPPDATAFOLDER directory:"

sql = "SELECT Directory.Directory FROM `Directory` WHERE `Directory_Parent` = 'COMMONAPPDATAFOLDER'"

'// Create a view
Set regView = oDatabase.OpenView(sql)
 
'// Execute the query
regView.Execute

'// File key variable
fileKey = ""
 
'// Fetch the row of data
Set regRecord = regView.Fetch

'// If no file
If regRecord Is Nothing Then
     wscript.echo "File Name not gotten"

'// Else file available to set permission on 
Else

    fileKey = regRecord.StringData(1)
    wscript.echo "Directory Key to set permission is: " &fileKey

    '// Above ok

    '// Select first
    '// Note wild syntax! '"& fileKey &"'
    sql = "SELECT `LockObject`,`Table`,`Domain`,`User`,`Permission` FROM `LockPermissions` WHERE `LockObject` = '"& fileKey &"'" 
        
     '// Create a view
    Set regView = oDatabase.OpenView(sql)
 
   '// Execute the query
    regView.Execute
    Set regRecord = regView.Fetch

     '// If not existing, we create a new record.
    If regRecord Is Nothing Then

       wscript.echo "Seting permission for " &fileKey       
       Set regRecord = oInstaller.CreateRecord(5)
 
       '// Create record
       regRecord.StringData(1) = fileKey	'LockObject
       regRecord.StringData(2) = "Directory" 	'Table   
       regRecord.StringData(3) = ""		'Domain empty   
       regRecord.StringData(4) = "Everyone"    	'User
       regRecord.IntegerData(5) = 268435456	'Permission GENERIC_ALL
 
       regView.Modify msiViewModifyInsert,regRecord
       wscript.echo "Permission set for " &fileKey

       '// Save changes
       oDatabase.Commit

   Else
      wscript.echo "Permission is already set for: " &fileKey 
   End If
 
End If 
Set regRecord = Nothing
Set oDatabase = Nothing
Set oInstaller = Nothing
